/*FILE:
*******************************************************************************
**
**  $Workfile: EXAMPLE.CPP $
**
**  $Revision: 6 $
**
**  $Date: 8/23/94 9:33p $
**
**  $Author: David $
**
**  Descrip:
**
**  Contents:
**
**  Notes:
**
**  See Also:
**
**  Copyright (C) 1994, Van de Vate Object-Oriented Software Solutions
**
*******************************************************************************
*/


/******************************************************************************
**  Include Header Files
*******************************************************************************
*/

#include "vossfmgr.hpp"
#include "example.rh"


/******************************************************************************
**  Define Private Constant Macros (const or #define)
*******************************************************************************
*/


/******************************************************************************
**  Define Private enums
*******************************************************************************
*/

/******************************************************************************
**  Define Private typedefs
*******************************************************************************
*/


/******************************************************************************
**  Define Private Inline Function Macros
*******************************************************************************
*/

/******************************************************************************
**  Declare Global Variables
*******************************************************************************
*/

HINSTANCE xhLibInstance    = (HINSTANCE) NULL;

/******************************************************************************
**  Function Private Prototypes (Listed in Alphabetical Order) (static)
*******************************************************************************
*/

//
//  define derived extension class.
//

class _export ExampleClass : public VFileManagerExtension
{
   private:
       HMENU hMenu;
   public:
       ExampleClass(void);
       ~ExampleClass(void) {DestroyMenu(hMenu);}
       HMENU       ExtensionMenu(void) {return hMenu;}
       const char *MenuName(void)      {return "Exa&mple";}
       const char *UserRegistration(void) const  {return "Please Register";}
};


class _export ExampleMenuItem  : public VFMXMenuItem
{
   private:
   protected:
   public:
       ExampleMenuItem(VFileManagerExtension *opExtension,int iMenuCommand)
                    : VFMXMenuItem(opExtension,iMenuCommand) {};

       void SetReadOnly(BOOL bOnOff=TRUE);

       int          IsEnabled(void) {return (Extension()->SelectionCount() != 0);}
       void         Execute(void)   {SetReadOnly(MenuCommand() == CM_READONLY);}
};


void ExampleMenuItem::SetReadOnly(BOOL bOnOff)
{
   int nSelections = Extension()->SelectionCount();

   for (int iSelection=0;iSelection<nSelections;iSelection++)
       {
        VFMXFileInfo& oFileInfo = Extension()->FileSelection(iSelection);
        if (bOnOff)
            oFileInfo.ReadOnly(VFMXFileInfo::set);
        else
            oFileInfo.ReadOnly(VFMXFileInfo::clear);
       }
   //
   //  force a refresh of the File Manager window.
   //
   Extension()->Refresh();
}

//
//  Define the body for AllocateExtension to return
//  an instance of the ExampleClass.
//
VFileManagerExtension * AllocateExtension(void)
{
   return new ExampleClass();
}


//
//  In the constructor we load our extension menu resource.
//
ExampleClass::ExampleClass(void)
             :VFileManagerExtension()
{
   hMenu = LoadMenu(xhLibInstance,MAKEINTRESOURCE(IDM_MENU));
   new ExampleMenuItem(this,CM_READONLY);
   new ExampleMenuItem(this,CM_WRITEABLE);
}



//
//  simple libmain
int FAR PASCAL LibMain(HINSTANCE hLibInst,WORD /*wDataSeg*/,WORD /*wHeapSize*/,
                       LPSTR /*lpszCmdLine*/)
{
   //
   // Set the global library instance handle
   //

   xhLibInstance = hLibInst;

   return 1;

}

/******************************************************************************
**                          E N D   O F   C O D E
*******************************************************************************
*/

/******************************************************************************
**                  R E V I S I O N  I N F O R M A T I O N
*******************************************************************************
**
** $History: EXAMPLE.CPP $
**
*******************  Version 6  *****************
**User: David        Date: 8/23/94    Time: 9:33p
**Branched in $/FILEMANAGER/Release 1.5/SOURCE
**
*******************  Version 5  *****************
**User: David        Date: 8/23/94    Time: 9:32p
**Updated in $/TOOLS/VOSSFMGR/SOURCE
**
*******************  Version 4  *****************
**User: David        Date: 8/21/94    Time: 11:30p
**Updated in $/TOOLS/VOSSFMGR/SOURCE
**Upgraded example code to example2.
**
*******************  Version 3  *****************
**User: David        Date: 8/18/94    Time: 8:46p
**Updated in $/TOOLS/VOSSFMGR/SOURCE
**
*******************  Version 2  *****************
**User: David        Date: 8/17/94    Time: 10:23p
**Updated in $/TOOLS/VOSSFMGR/SOURCE
**
*******************  Version 1  *****************
**User: David        Date: 8/15/94    Time: 11:05p
**Created in $/TOOLS/VOSSFMGR/SOURCE
**
*******************************************************************************
*/

/******************************************************************************
**                          E N D   O F   FILE
*******************************************************************************
*/

